import React from 'react';
import * as FIBER from '@react-three/fiber';
import CustomShaderMaterial from './vanilla';
import { _CSMParam } from './types';
export * from './types';
export declare type iCSMProps = _CSMParam & AllMaterialProps;
export declare type AllMaterialProps = FIBER.MeshPhongMaterialProps & //
FIBER.MeshPhysicalMaterialProps & FIBER.MeshToonMaterialProps & FIBER.MeshBasicMaterialProps & FIBER.MeshLambertMaterialProps & FIBER.MeshStandardMaterialProps & FIBER.PointsMaterialProps;
declare global {
    namespace JSX {
        interface IntrinsicElements {
            customShaderMaterial_: FIBER.Node<CustomShaderMaterial, typeof CustomShaderMaterial>;
        }
    }
}
declare const _default: React.ForwardRefExoticComponent<Pick<iCSMProps, "baseMaterial" | "fragmentShader" | "vertexShader" | "uniforms" | "patchMap" | "cacheKey" | "color" | "specular" | "shininess" | "opacity" | "map" | "lightMap" | "lightMapIntensity" | "aoMap" | "aoMapIntensity" | "emissive" | "emissiveIntensity" | "emissiveMap" | "bumpMap" | "bumpScale" | "normalMap" | "normalMapType" | "normalScale" | "displacementMap" | "displacementScale" | "displacementBias" | "specularMap" | "alphaMap" | "envMap" | "combine" | "reflectivity" | "refractionRatio" | "wireframe" | "wireframeLinewidth" | "wireframeLinecap" | "wireframeLinejoin" | "flatShading" | "alphaTest" | "alphaToCoverage" | "blendDst" | "blendDstAlpha" | "blendEquation" | "blendEquationAlpha" | "blending" | "blendSrc" | "blendSrcAlpha" | "clipIntersection" | "clippingPlanes" | "clipShadows" | "colorWrite" | "defines" | "depthFunc" | "depthTest" | "depthWrite" | "fog" | "name" | "polygonOffset" | "polygonOffsetFactor" | "polygonOffsetUnits" | "precision" | "premultipliedAlpha" | "dithering" | "side" | "shadowSide" | "toneMapped" | "transparent" | "vertexColors" | "visible" | "stencilWrite" | "stencilFunc" | "stencilRef" | "stencilWriteMask" | "stencilFuncMask" | "stencilFail" | "stencilZFail" | "stencilZPass" | "userData" | "clearcoat" | "clearcoatMap" | "clearcoatRoughness" | "clearcoatRoughnessMap" | "clearcoatNormalScale" | "clearcoatNormalMap" | "ior" | "sheen" | "sheenColor" | "sheenRoughness" | "transmission" | "transmissionMap" | "attenuationDistance" | "attenuationColor" | "specularIntensity" | "specularColor" | "specularIntensityMap" | "specularColorMap" | "roughness" | "metalness" | "roughnessMap" | "metalnessMap" | "envMapIntensity" | "gradientMap" | "size" | "sizeAttenuation" | "id" | "isMaterial" | "needsUpdate" | "type" | "uuid" | "version" | "clone" | "copy" | "dispose" | "onBeforeCompile" | "customProgramCacheKey" | "setValues" | "toJSON" | "addEventListener" | "hasEventListener" | "removeEventListener" | "dispatchEvent" | "attach" | "args" | "children" | "key" | "onUpdate" | "metal" | "sheenColorMap" | "sheenRoughnessMap" | "thickness" | "thicknessMap" | "isMeshStandardMaterial"> & React.RefAttributes<CustomShaderMaterial>>;
export default _default;
